
         PAGE      ,120

         TITLE     XA.COM

         ; EXTENDED ANSI INTERPRETER TO CONVERT 'ENGLISH' LIKE COMMANDS INTO
         ; ANSI TYPE ESCAPE SEQUENCES. CALL AS XA.COM FILENAME/[COMMAND
         ; STRING]

CSEG     SEGMENT   PARA      PUBLIC    'CODE'
         ASSUME    CS:CSEG,DS:CSEG,ES:CSEG

         ORG       100H

ENTRY:   JMP       START     ; SKIP OVER DATA DEFINITION AREA

DATA:              ; * SCREEN MESSAGE TEXT DEFINITIONS  *

CMESS    DB        10,13,'    ',27,'[7m'
         DB        ' XA [ VER 1.0 ]. EXTENDED ANSI INTERPRETER'
         DB        '  Written by P. Grove 1987 '
         DB        27,'[0m',10,13,10,13,'$'
IMESS    DB        ' For command syntax type XA [HELP]',10,13,'$'
KMESS    DB        ' KEY(S) SUCCESSFULLY DEFINED ',10,13,'$'
EMESS    DB        10,13,10,13,27,'[7m'
         DB        ' XA ERROR, OPERATION ABORTED '
         DB        27,'[0m',10,13,'$'
HLPTXT   DB        10,13
         DB        '  XA NEEDS DEVICE = ANSI.SYS IN YOUR CONFIG.SYS FILE'
         DB        10,13,10,13,'  VALID COMMANDS IN THIS VERSION....'
         DB        10,13,10,13
         DB        '  [ WRITE "text" ]           [ AT line;column ]',10,13
         DB        '  [ INK ( LIGHT ) colour ]   [ PAPER colour ]',10,13
         DB        '  [ REVERSE ] [ NORMAL ] [ BRIGHT ] [ CLS ] [ UNDERLINE ]'
         DB        10,13
         DB        '  [ FLASH ]  [ SCREEN n ] where n = 0 to 7',10,13
         DB        '  [ COFF  ]  disable copyright message ',10,13
         DB        '  [ KEY keyspecifier=newdefinition ]',10,13
         DB        '  [ KEYS ] displays keycodes',10,13
         DB        '  [ PANEL border;depth;width;shadow colour  (0-7) ] '
         DB        10,13,'  displays a panel with  optional border and shadow '
         DB        10,13,10,13
         DB        '  VALID COLOURS FOR PAPER AND INK COMMANDS ARE:'
         DB        10,13,'  black, red, green, yellow, blue, '
         DB        'magenta, cyan or white',10,13,10,13,10,13
         DB        10,13,'$'
KEYTXT   DB        'ASCII KEY CODES.....',13,10
         DB        '  0 - 9 = 48 - 57',10,13
         DB        '  A - Z = 65 - 90',10,13
         DB        '  a - z = 97 - 122',10,13
         DB        10,13,'EXTENDED ASCII CODES.....',10,13
         DB        '  These codes are all prefixed by a 0 byte i.e. 0;n',10,13
         DB        '  Alt + Q - P      = 0;16 - 0;25',10,13
         DB        '  Alt + A - L      = 0;30 - 0;38',10,13
         DB        '  Alt + Z - M      = 0;44 - 0;50',10,13
         DB        '  F1 - F10         = 0;59 - 0;68',10,13
         DB        '  Shift + F1 - F10 = 0;84 - 0;93',10,13
         DB        '  Ctrl + F1 - F10  = 0;94 - 0;103',10,13
         DB        '  Alt + F1 - F10   = 0;104 - 0;113',10,13
         DB        '  Alt + 1 - 0      = 0;120 - 0;129',10,13
         DB        10,13,'$'


         ;     *  COMMONLY USED ESCAPE SEQUENCES  *

NLESC    DB        27,'[0m$'
BTESC    DB        27,'[1m$'
UEESC    DB        27,'[4m$'
BKESC    DB        27,'[5m$'
REESC    DB        27,'[7m$'
CSESC    DB        27,'[2J$'
ATESC    DB        27,'['
ATESC2   DB        ?,?,?,?,?,?,?,?,?,?
IKESC    DB        27,'['
IKESC2   DB        ?,?,'m$'
SCESC    DB        27,'[=',?,'h$'
BPESC    DB        7,'$'


         ;       *  COMMAND LOOKUP TABLE  *

CTBL     DB        'we'
         DW        WRITE
         DB        'at'
         DW        AT
         DB        're'
         DW        RVERSE
         DB        'nl'
         DW        NORMAL
         DB        'ik'
         DW        INK
         DB        'pr'
         DW        PAPER
         DB        'cs'
         DW        CLS
         DB        'bt'
         DW        BRIGHT
         DB        'fh'
         DW        FLASH
         DB        'hp'
         DW        HELP
         DB        'ue'
         DW        ULINE
         DB        'sn'
         DW        SCREEN
         DB        'ky'
         DW        KEY
         DB        'ks'
         DW        KEYS
         DB        'bp'
         DW        BEEP
         DB        'pl'
         DW        PANEL
         DB        'cf'
         DW        COFF
         DB        '0000'    ; TABLE END

         ;      *  INK AND PAPER PARAMETER LOOKUP TABLES  *

ITBL     DB        'bk30rd31gn32yw33be34ma35cn36we370000'
PTBL     DB        'bk40rd41gn42yw43be44ma45cn46we470000'


                   ; * *  VARIABLES * *

CPYFLG   DB        1         ; COPYRIGHT MESSAGE FLAG INITIALISED TO ON
KYFLAG   DB        0         ; FLAGS A KEY DEFINITION
CURCOM   DW        ?         ; TEMPORARY POINTER STORE FOR CURRENT COMMAND
PNLCT    DB        ?         ; PANEL PARAMETER COUNT STORE
PNLB     DB        ?         ; PANEL BORDER TYPE STORE
PNLD     DB        ?         ; PANEL DEPTH
PNLW     DB        ?         ; WIDTH
SHAD     DB        ?         ; AND SHADOW ATTRIBUTE
PRATT    DB        '40'      ; TEMPORARY STORE FOR BACKGROUND ATTRIBUTE
                             ; INITIALLY BLACK
PRESC    DB        27,'[40m$' ; PAPER ESCAPE SEQUENCE FOR SHADOW

         ; THREE SETS OF DATA FOR NO, SINGLE OR DOUBLE BORDERS

BRDR0    DB        32,32,32,32,32,32   ; 6 SPACES FOR NO BORDER
BRDR1    DB        218,196,191,179,217,192  ; 1 LINE BORDER
BRDR2    DB        201,205,187,186,188,200  ; 2 LINE BORDER

         ; WHICH ARE INSERTED HERE AT RUN TIME

TLCH     DB        ?         ; TOP LEFT CHARACTER
TBCH     DB        ?         ; ETC. ETC.
TRCH     DB        ?
SDCH     DB        ?
BRCH     DB        ?
BLCH     DB        ?


SHESC    DB        27,'[33m0$' ; SHADOW ESCAPE SEQUENCE

                   ; * CONSTANTS *

FALSE    =         00H
TRUE     =         255D

         ; DEFFINE A LABEL CALLED BUFFER WHICH WILL POINT TO AN AREA OF
         ; MEMORY BEYOND THE PROGRAM IN WHICH TO LOAD A COMMAND FILE

BUFFER:  DW        LBYTE + 10


START    PROC      NEAR      ; START OF ACTUAL CODE

         ; * FIRST CHECK FOR ANY PARAMETERS *

         MOV       BX,80H    ; POINT TO PARAMETER LENGTH BYTE IN PROGRAM
         MOV       AL,[BX]   ; SEGMENT PREFIX, THEN FETCH IT.
         CMP       AL,0      ; ANY PARAMETERS?
         JNZ       PARS
CRIGHT:  LEA       DX,CMESS  ; IF NO PARS. PRINT COPYRIGHT MESSAGE
         MOV       AH,9
         INT       21H
         LEA       DX,IMESS  ; AND HELP PROMPT
         MOV       AH,9
         INT       21H       ;
         RET

         ; * NOW CHECK FOR A FILENAME *

PARS:    MOV       BX,82H
SKIPSP:  MOV       AL,[BX]
         CMP       AL,20H    ; IGNORE LEADING SPACES
         JNZ       BEGIN
         INC       BX
         JMP       SKIPSP
BEGIN:   CMP       AL,5BH    ; IS FIRST CHAR.IN PARAMETER BLOCK A [?
         JNZ       FILE      ; NO SO SKIP TO FILE LOAD
EOF:     MOV       BX,80H
         MOV       AL,[BX]   ; FIND LENGTH OF PARAMETERS
         MOV       AH,00
         ADD       AX,BX
         MOV       BX,AX
         INC       BX        ; BX POINTS TO CR. AT END OF COMMAND PARAMETER
         MOV       AL,1AH    ; LIST. REPLACE THIS WITH ^Z END OF FILE MARKER
         MOV       [BX],AL   ;
         MOV       BX,82H    ; BX > START OF PARAMETERS IN COMMAND SO NOW
         JMP       SCAN      ; SKIP AHEAD TO SCAN THROUGH COMMANDS

         ; THIS SECTION OF CODE DEALS WITH LOADING A COMMAND FILE

FILE:    LEA       SI,CURCOM
         MOV       [SI],BX   ; STORE FILENAME POINTER IN CASE OF ERROR
         MOV       DX,BUFFER ; POINT DX AT BUFFER THEN CALL SUBROUTINE TO
         CALL      FLOAD     ; LOAD FILE POINTED TO BY BX
         CMP       AL,FALSE  ; ZERO IN AL = ERROR IN FLOAD
         JNZ       SCAN
         CALL      ERROR     ; ERROR IN FLOAD
         RET

         ; * ARRIVE HERE WITH BX > START OF DATA, THEN PROCEED TO  *
         ; * IDENTIFY COMMANDS AND CALL RELEVANT SUBROUTINES.  ON  *
         ; *  RETURN, A VALUE OF 0 IN AL INDICATES AN ERROR

SCAN:    MOV       AL,[BX]   ; FETCH DATA BYTE
         CMP       AL,1AH    ; IS IS ^Z ?
         JNZ       CHKBR
FINISH:  LEA       BX,CPYFLG ; COMMANDS ALL FINISHED SUCCESFULLY SO CHECK
         CMP       BYTE PTR [BX],0  ; WETHER COPYRIGHT FLAG IS OFF
         JZ        OUT       ; YES SO NO COPYRIGHT MESSAGE
         LEA       BX,KYFLAG ; WERE ANY KEYS DEFINED?
         MOV       AL,[BX]
         CMP       AL,0      ;
         JZ        OUT       ; NO
         LEA       DX,CMESS  ; KEYS WERE DEFINED AND MESSAGE FLAG IS ON
         MOV       AH,9      ; SO PRINT MESSAGES........
         INT       21H
         LEA       DX,KMESS
         MOV       AH,9
         INT       21H
OUT:     MOV       AX,4C00H  ; LOAD DOS EXIT FUNCION CODE
         INT       21H       ; AND RETURN TO DOS

         ; ARRIVE HERE WITH BX > A NON EOF CHARACTER

CHKBR:   CMP       AL,5BH    ; IS IT [ ?
         JZ        GO
         INC       BX        ; NO SO CONSIDER NEXT BYTE
         JMP       SCAN
GO:      LEA       SI,CURCOM
         MOV       [SI],BX   ; STORE CURRENT COMMAND POINTER
         CALL      GETWRD    ; SCAN AHEAD FOR COMMAND

         ; GETWRD RETURNS  1ST LETTER OF THE TEXT POINTED TO BY BX
         ; IN CL, AND THE LAST IN CH *

         INC       BX        ; BX > NEXT DATA
         MOV       DX,BX     ; SAVE DATA POINTER IN DX
         LEA       BX,CTBL   ; POINT BX AT COMMAND TABLE
         CALL      LOOKUP    ; FIND CX ENTRY IN COMMAND TABLE

         ;  LOOKUP RETURNS BX POINTING TO A VALID  ENTRY
         ; IN THE COMMAND LOOKUP TABLE OR AX = 0000H IF NOT FOUND

         CMP       AX,0000H  ; CHECK FOR AN ERROR
         JNZ       COMMAND
         JMP      ERROR     ; COMMAND NOT FOUND

         ; A VALID COMMAND HAS BEEN FOUND SO MOVE BX FORWARD TO ITS
         ; VECTOR ADDRESS AND CALL IT

COMMAND: INC       BX
         INC       BX        ; BX > VECTOR
         MOV       AX,[BX]   ; PASS VECTOR TO AX
         MOV       BX,AX     ; THEN TO BX
         CALL      BX        ; CALL COMMAND SUBROUTINE

         ; THE RELEVANT COMMAND SUBROUTINE IS NOW CALLED WITH  DX > CURRENT
         ; DATA POSITION WHICH SHOULD BE THE CHARACTER AFTER THE '['
         ; EACH SUBROUTINE RETURNS HERE WITH BX > NEXT POSSIBLE DATA AND
         ; AL = 00H IF AN ERROR WAS DISCOVERED

         CMP       AL,FALSE  ; TEST FOR ERROR
         JNZ       SCAN      ; LOOK FOR MORE COMMANDS IF NO ERROR
         JMP       ERROR     ; OTHERWISE REPORT ERROR AND EXIT

         ; = = = = = = = = = = = = = = = = = = = = = = = = = = = = =


         ; * * * * * * * SUBROUTINES * * * * * * * *

         ; ERROR MESSAGE ROUTINE, EXIT TO DOS FROM HERE IF AN ERROR WAS
         ; DISCOVERED, AFTER RE-DISPLAYING THE OFFENDING COMMAND

ERROR:   LEA       SI,CURCOM
         MOV       BX,[SI]   ; FETCH POINTER TO ERRONEOUS COMMAND
         MOV       AH,6      ; SINGLE CHARACTER OUTPUT FUNCTION
ERRLOOP: MOV       DL,[BX]   ; FETCH CHARACTER
         CMP       DL,']'    ; PRINT COMMAND UP TO ']'
         JZ        ONEMORE   ; +1
         CMP       DL,0AH    ; OR UP TO EOF MARKER
         JZ        ERREND
         CMP       DL,0D
         JZ        ERREND    ; OR END OF COMMAND LINE
         INT       21H
         INC       BX
         JMP       ERRLOOP

ONEMORE: INT       21H       ; PRINT ']'

ERREND:  LEA       DX,EMESS  ; POINT DX AT ERROR MESSAGE
         MOV       AH,9
         INT       21H
         MOV       AX,4C01H  ; SET EXIT CODE WITH AN ERRORLEVEL OF 1
         INT       21H       ; AND RETURN TO DOS

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

         ; * LOAD FILE SUBROUTINE *

         ; * LOAD FILE - DX > BUFFER - BX > FSPEC.  *
         ; * EXIT WITH NON ZERO IN AL FOR ERROR     *

FLOAD:   MOV       BX,80H    ; GET FSPEC. LENGTH
         MOV       AL,[BX]
         MOV       AH,0
         ADD       AX,BX
         MOV       BX,AX
         INC       BX        ; BX > BYTE AFTER FSPEC.
         MOV       AL,0
         MOV       [BX],AL   ; TERMINATE FSPEC. WITH 00H
         PUSH      DX        ; SAVE BUFFER POINTER
         MOV       DX,82H    ; DX > FSPEC.
OPEN:    MOV       AH,3DH
         INT       21H       ; OPEN FILE. A FILE 'HANDLE' IS RETURNED IN AX
         POP       DX        ; RECOVER BUFFER POINTER
         JNC       LOAD      ; A CARRY INDICATES FILE NOT FOUND
         MOV       AL,FALSE  ; ERROR FLAG
         RET
LOAD:    MOV       BX,AX     ; PASS FILE HANDLE TO BX
         PUSH      BX        ; AND SAVE IT
         MOV       CX,1      ; BYTE COUNT
LDLOOP:  MOV       AH,3FH    ; LOAD FUNCTION.
         INT       21H       ; LOAD A BYTE AT A TIME
         CMP       AX,1
         JNZ       LOADED
         INC       DX        ; INC. BUFFER POINTER
         JMP       LDLOOP
LOADED:  MOV       BX,DX
         INC       BX        ; BX > BUFFER END + 1
         MOV       AL,1AH
         MOV       [BX],AL   ; MARK END OF BUFFER WITH ^Z
         POP       BX        ; RECOVER HANDLE
CLOSE:   MOV       AH,3EH    ; CLOSE FILE FUNCTION.
         INT       21H
         MOV       BX,BUFFER ; BX > START OF DATA
         MOV       AL,TRUE   ; FLAG OK
         RET                 ; AND RETURN TO BEGIN SCAN

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

         ; * GET WORD SUBROUTINE *

         ; * CALLED WITH BX > FIRST POSSIBLE CHAR. EXIT WITH 1ST.   *
         ; * LETTER IN CL, LAST LETTER IN CH                        *                 *

GETWRD:  CALL      FNDCHR    ; FIND FIRST CHARACTER
                             ; RETURN WITH BX > EITHER A/Z OR  a/z
         MOV       CL,[BX]   ; FIRST LETTER TO CL
         CALL      NONCHR    ; FIND FIRST NON CHARACTER
         DEC       BX        ; THEN BACKUP SO THAT BX > LAST LETTER
         MOV       CH,[BX]   ; CX NOW CONTAINS FIRST AND LAST LETTER  OF
         OR        CX,2020H  ; A POSSIBLE COMMAND. NOW FORCE LOWER CASE
         RET                 ; RET WITH CX = 1ST/LAST LETTERS
                             ; BX > LAST LETTER
         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

         ; * FIND CHARACTER SUBROUTINE *
         ; * CALLED WITH BX > FIRST BYTE - EXIT WITH BX > FIRST a-z/A-Z

FNDCHR:  MOV       AL,[BX]   ; FETCH DATA
         OR        AL,20H    ; FORCE LOWER CASE
aCHK:    CMP       AL,61H    ; COMPARE WITH 'a'
         JGE       zCHK      ; YES SO CHECK LESS THAN 'z'
         JMP       NXTCHR
zCHK:    CMP       AL,7AH
         JG        NXTCHR
         RET                 ; RET WITH BX > CHAR
NXTCHR:  INC       BX
         JMP       FNDCHR    ; LOOP BACK FOR NEXT CHARACTER

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

         ; * FIND FIRST NON-CHARACTER SUBROUTINE                *
         ; * CALLED WITH BX > DATA - RETURN WITH BX > FIRST NCHR

NONCHR:  MOV       AL,[BX]         ; FETCH DATA
         OR        AL,20H          ; FORCE LOWER CASE
         CMP       AL,61H
         JL        NOCHR           ; < a ?
         CMP       AL,7AH
         JG        NOCHR           ; > z ?
         INC       BX
         JMP       NONCHR
NOCHR:   RET                       ; EXIT WITH BX > NON CHAR


         ; - - - - - - - - - - - - - - - - - - - - - - - - - -

         ; * LOOKUP SUBROUTINE   FIND FIRST 2 BYTE MATCH FOR CX IN A TABLE
         ; * POINTED TO BY BX. AN ENTRY OF 0000H MARKS END OF TABLE.

LOOKUP:  MOV       AX,[BX]   ; FETCH DATA
         CMP       AX,0000H  ; END OF TABLE ?
         JZ        EXITLK
         CMP       AX,CX     ; MATCH ?
         JZ        EXITLK
         INC       BX
         INC       BX        ; BX > NEXT TABLE ENTRY
         JMP       LOOKUP
EXITLK:  RET                 ; RET IF MATCH OR END

         ; = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

         ; * * * * * * * * * * COMMAND SUBROUTINES * * * * * * * * * * *

         ; * CALLED WITH DX > CURRENT DATA POSITION
         ; * RETURN WITH BX > NEXT POSSIBLE COMMAND
         ; * AND AL = 00H ON ERROR


WRITE:   MOV       BX,DX     ; BX > AFTER 'WRITE'
FINDQ:   MOV       AL,[BX]
         CMP       AL,"'"    ; IS IT '
         JZ        GOWRT
         CMP       AL,'"'    ; OR IS IT "
         JZ        GOWRT
         INC       BX
         JMP       FINDQ
GOWRT:   INC       BX        ; BX > TEXT
         MOV       DX,BX
QSRCH:   INC       BX        ; SEARCH FOR CLOSING QUOTE TO MATCH AL
         MOV       AH,[BX]
         CMP       AH,AL
         JNZ       QSRCH
         PUSH      AX        ; SAVE CLOSING QUOTE
         PUSH      BX        ; AND POINTER
         MOV       AL,'$'    ; REPLACE CLOSING QUOTE WITH THE DOS STRING
         MOV       [BX],AL   ; OUTPUT ROUTINES END OF STRING MARKER
         MOV       AH,9
         INT       21H       ; PRINT TEXT
         POP       BX
         POP       AX
         MOV       [BX],AH   ; RE-INSTATE CLOSING QUOTE
         INC       BX        ; BX > CHARACTER AFTER CLOSING QUOTE
         MOV       AL,TRUE   ; FLAG OK
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

AT:      MOV       BX,DX     ; BX > DATA
ATSPC:   MOV       AL,[BX]
         CMP       AL,20H    ; SKIP ANY LEADING SPACES
         JNZ       ATGO
         INC       BX
         JMP       ATSPC
ATGO:    LEA       DX,ATESC2  ; DX > 'AT' ESC. SEQ. BUFFER +2
         DEC       DX
         DEC       BX
ATLOOP:  INC       DX
         INC       BX
         MOV       AL,[BX]   ; FETCH PARAMETERS OF 'AT' COMMAND
         CMP       AL,30H    ; < 0 ?
         JL        ATEND     ; > ; ?
         CMP       AL,3BH
         JG        ATEND
         XCHG      DX,BX     ; SWAP POINTERS
         MOV       [BX],AL   ; INSERT AT DATA INTO BUFFER
         XCHG      DX,BX     ; RESTORE POINTERS
         JMP       ATLOOP
ATEND:   XCHG      DX,BX
         MOV       AX,2448H  ; H$
         MOV       [BX],AX
         XCHG      DX,BX     ; BX > END OF AT DATA
         LEA       DX,ATESC  ; REPOINT DX AT ESC. SEQ.
         PUSH      BX
         MOV       AH,9      ; CORRECT CURSOR POSITIONING ESCAPE SEQUENCE
         INT       21H       ; HAS BEEN ASSEMBLED IN THE BUFFER SO DO IT.
         POP       BX
         MOV       AL,TRUE   ; FLAG OK
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

RVERSE:  PUSH      DX        ; SAVE DATA POINTER
         LEA       DX,REESC  ; POINT DX AT REVERSE ESCAPE SEQUENCE
         MOV       AH,9
         INT       21H       ; AND SEND IT
         MOV       AL,TRUE   ; FLAG NO ERRORS
         POP       BX        ; RECOVER DATA POINTER. NO PARAMETERS ARE GIVEN
         RET                 ; SO IT SHOULD POINT TO END OF COMMAND

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

NORMAL:  PUSH      DX
         LEA       DX,NLESC  ; SAME PROCEDURE AS ABOVE
         MOV       AH,9
         INT       21H
         MOV       AL,TRUE
         POP       BX
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

BRIGHT:  PUSH      DX
         LEA       DX,BTESC  ; AND AGAIN FOR BRIGHT
         MOV       AH,9
         INT       21H
         MOV       AL,TRUE
         POP       BX
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

FLASH:   PUSH      DX
         LEA       DX,BKESC   ; AND FOR FLASH
         MOV       AH,9
         INT       21H
         MOV       AL,TRUE
         POP       BX
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

ULINE:   PUSH      DX
         LEA       DX,UEESC   ; SAME FOR UNDERLINE
         MOV       AH,9
         INT       21H
         MOV       AL,TRUE
         POP       BX
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

CLS:     PUSH      DX
         LEA       DX,CSESC   ; ITS ALL QUITE EASY REALLY
         MOV       AH,9
         INT       21H
         LEA       BX,PRATT
         MOV       AX,[BX]   ; FETCH LAST PAPER ATTRIBUTE USED
         LEA       BX,PRESC+2 ; POINT TO PAPER ESCAPE SEQUENCE
         MOV       [BX],AX   ; STORE IN STRING

         MOV       AL,TRUE
         POP       BX
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

INK:     MOV       BX,DX     ; THIS ONE IS A BIT HARDER THOUGH. FIRST CALL
INK2:    CALL      GETWRD    ; GETWRD. CX NOW = 1ST/LAST LETTERS OF PARAMETER
         CMP       CX,746CH  ; IS 1ST WORD 'LIGHT'
         JNZ       NOTLT
LIGHT:   PUSH      BX        ; FIRST PARAMETER OF INK COMMAND WAS LIGHT
         CALL      BRIGHT    ; SO CALL BRIGHT SUBROUTINE
         POP       BX        ; RECOVER POINTER
         INC       BX        ; BX > PAST 'LIGHT'
         JMP       INK2      ; AND LOOP BACK FOR THE NEXT PARAMETER
NOTLT:   PUSH      BX
         LEA       BX,ITBL   ; BX > INK TABLE
COLOR:   CALL      LOOKUP    ; LOOKUP THE COLOUR
         INC       BX
         INC       BX
         MOV       CX,[BX]   ; FETCH CODE
         POP       BX
         CMP       AX,0000H  ; IF THE COLOUR CODE IS 0000 IT WAS NOT VALID
         JNZ       INKGO
         RET                 ; SO RETURN WITHAN ERROR FLAGGED

INKGO:   PUSH      BX
         LEA       BX,IKESC2 ; POINT BX > POSITION IN ATTRIBUTE ESCAPE
         MOV       [BX],CX   ; SEQUENCE IN WHICH TO INSERT INK CODE. INSERT
         LEA       DX,IKESC  ; AND SEND TO DOS OUTPUT ROUTINE
         PUSH      CX
         MOV       AH,9
         INT       21H
         POP       CX
         CMP       CL,'4'    ; WAS IT A PAPER CODE
         JNZ       INKEX     ; NO
         LEA       BX,PRATT  ; POINT TO TEMP. PAPER COLOUR STORE
         MOV       [BX],CX   ; AND STORE

INKEX:   POP       BX
         MOV       AL,TRUE   ; FLAG OK
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - -

PAPER:   MOV       BX,DX
         CALL      GETWRD    ; GET PAPER COLOUR STRING
         PUSH      BX
         LEA       BX,PTBL   ; BX > PAPER TABLE. NOW CALL  INK
         JMP       COLOR     ; ROUTINE TO GET THE ATTRIBUTE AND SET IT



         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

HELP:    CALL      CLS
         LEA       DX,CMESS
         MOV       AH,9
         INT       21H       ; PRINT COPYRIGHT
         LEA       DX,HLPTXT
         MOV       AH,9
         INT       21H       ; AND HELPTEXT
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


SCREEN:  MOV       BX,DX     ; BX > SPACE AFTER COMMAND
SCLOOP:  INC       BX
         MOV       AL,[BX]   ; FETCH OPERAND
         CMP       AL,32
         JZ        SCLOOP    ; IGNORE LEADING SPACES
         PUSH      BX        ; SAVE POINTER
         LEA       BX,SCESC+3 ; POINT TO SPACE FOR SCREEN OPERAND
         MOV       [BX],AL
         LEA       DX,SCESC
         MOV       AH,9
         INT       21H       ; SET SCREEN MODE
         POP       BX        ; RECOVER POINTER
         INC       BX
         MOV       AL,TRUE   ; FLAG O/K
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

KEY:     MOV       BX,DX     ; BX > SPACE AFTER COMMAND
KEYLP:   INC       BX
         MOV       AL,[BX]
         CMP       AL,32
         JZ        KEYLP     ; IGNORE LEADING SPACES
         DEC       BX
         DEC       BX        ; BX > KEYSPEC-2
         MOV       AX,[BX]   ; SAVE 2 CHARS. WHICH WILL BE OVERWRITTEN
         PUSH      BX
         PUSH      AX
         MOV       DX,BX     ; DX > ESCAPE SEQUENCE
         MOV       AH,'['
         MOV       AL,27
         MOV       [BX],AX   ; SET ESC,[
         INC       BX
         INC       BX        ; BX > KEYSPEC.
SEPLK:   INC       BX
         MOV       AL,[BX]
         CMP       AL,'='
         JNZ       SEPLK
         MOV       AL,';'
         MOV       [BX],AL   ; TRANSLATE '=' TO ';'
ENDLK:   INC       BX
         MOV       AL,[BX]
         CMP       AL,']'
         JNZ       ENDLK
         MOV       AX,[BX]
         PUSH      BX
         PUSH      AX        ; SAVE CHARS. TO BE OVERWRITTEN
         MOV       AX,'$p'
         MOV       [BX],AX
         MOV       AH,9
         INT       21H       ; SEND DEFINITION
         LEA       BX,KYFLAG
         MOV       AL,0FFH
         MOV       [BX],AL   ; FLAG A KEY DEFINITION  HAS BEEN PERFORMED
         POP       AX
         POP       BX
         MOV       DX,BX
         MOV       [BX],AX   ; REWRITE CHARS AT END OF STATEMENT
         POP       AX
         POP       BX
         MOV       [BX],AX   ; REWRITE CHARS AT START
         MOV       BX,DX
         MOV       AL,TRUE   ; FLAG OK
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - -

KEYS:    CALL      CLS
         LEA       DX,CMESS
         MOV       AH,9
         INT       21H       ; PRINT COPYRIGHT MESSAGE
         LEA       DX,KEYTXT
         MOV       AH,9
         INT       21H       ; PRINT KEYCODE TEXT
         MOV       AL,TRUE
         RET

         ; - - - - - - - - - - - - - -- - - - - - - - - - - - - - - -

BEEP:    PUSH      DX        ; SAVE DATA POINTER
         LEA       DX,BPESC
         MOV       AH,9
         INT       21H       ; OUTPUT ^G CHARACTER
         POP       BX
         INC       BX        ; MOVE DATA POINTER FORWARD
         MOV       AL,TRUE   ; FLAG OK
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

COFF:    LEA       BX,CPYFLG
         MOV       AL,0
         MOV       [BX],AL   ; SET CPYFLG TO 0
         MOV       BX,DX
         INC       BX        ; MOVE DATA POINTER FORWARD
         MOV       AL,TRUE
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


PANEL:   LEA       BX,SHAD   ; POINT TO SHADOW ATTRIBUTE STORE
         MOV       AL,255
         MOV       [BX],AL   ; ENSURE SHADOW IS OFF TO START WITH
         LEA       BX,PNLCT
         SUB       AL,AL
         MOV       [BX],AL   ; ZERO PARAMETER COUNT

         MOV       BX,DX     ; BX > COMMAND LINE
         LEA       SI,PNLB   ; POINT TO FIRST DATA STORE, BORDER TYPE

PNLP1:   CALL      NXNUM     ; POINT BX AT NEXT NUMBER/CHAR > 0
         CMP       BYTE PTR [BX],']'
         JZ        PAREND    ; END OF PARAMETER  LIST
         CALL      A2B       ; GET B,H,W & S INTO AL
         CMP       AH,0      ; AH <> 0 = ERROR
         JNZ       PNLERR
         MOV       [SI],AL   ; STORE PARAMETER
         INC       SI        ; INC. VARIABLE POINTER
         PUSH      BX
         LEA       BX,PNLCT
         INC       BYTE PTR [BX] ; INCREMENT PARAMETER COUNT
         POP       BX
         JNZ       PNLP1

         ; PARAMETERS HAVE BEEN STORED IN MEMORY SO NOW CHECK HOW MANY

PAREND:  LEA       SI,PNLCT
         MOV       AL,[SI]
         CMP       AL,3
         JL        PNLERR    ; 3 PARAMETERS ARE COMPULSORY
         CMP       AL,4
         JG        PNLERR    ; >4 MEANS TOO MANY
         INC       SI
         MOV       AL,[SI]
         CMP       AL,3
         JGE       PNLERR    ; BORDER >2 = ERROR
         INC       SI
         MOV       AX,[SI]
         CMP       AL,2      ; WIDTH <2 = ERROR
         JLE       PNLERR
         CMP       AH,2
         JLE       PNLERR   ; AND DEPTH
         INC       SI
         INC       SI
         MOV       AL,[SI]
         CMP       AL,7
         JG        PNLERR    ; ATT. > 15 = ERROR
         LEA       SI,SHESC+3
         OR        AL,30H    ; CONVERT BACK TO ASCII DIGIT
         MOV       [SI],AL   ; MOVE SHADOW ATTRIBUTE INTO ESCAPE SEQUENCE
         JMP       PNLGO

PNLERR:  MOV       AL,FALSE  ; FLAG AN ERROR
         RET                 ; RETURN

         ; PARAMETERS INSTALLED SO SET UP BORDER DATA


PNLGO:   LEA       SI,PNLB
         MOV       AL,[SI]   ; FETCH BORDER TYPE
         CMP       AL,0
         JZ        TYPE0
         CMP       AL,1
         JZ        TYPE1
         CMP       AL,2
         JZ        TYPE2
         JMP       PNLERR    ; INVALID BORDER TYPE HAS BEEN GIVEN

TYPE0:   LEA       SI,BRDR0  ; POINT SI AT BORDER TYPE 0 DATA
         JMP       BRDSET
TYPE1:   LEA       SI,BRDR1  ; OR TYPE 1
         JMP       BRDSET
TYPE2:   LEA       SI,BRDR2  ; OR TYPE 2

BRDSET:  LEA       DI,ES:TLCH   ; DESTINATION OF FIRST BYTE OF BORDER DATA
         MOV       CX,6         ; THERE ARE 6 DATA BYTES
         CLD
         REP       MOVSB        ; MOVE THEM


         ; NOW PRINT THE TOP LINE OF THE PANEL


PNLPRNT: PUSH      BX        ; SAVE COMMAND POINTER

TOP:     CALL      SCP       ; SAVE CURSOR POSITION
         LEA       BX,TLCH
         MOV       DL,[BX]   ; DL=TOP LEFT CHAR.
         MOV       AH,6
         INT       21H
         LEA       BX,TBCH
         MOV       DL,[BX]   ; DL = TOP CHAR.
         LEA       BX,PNLW
         MOV       CL,[BX]
         DEC       CL
         DEC       CL
TOPLP:   INT       21H
         DEC       CL
         JNZ       TOPLP     ; PRINT TO TOP RIGHT
         LEA       BX,TRCH
         MOV       DL,[BX]
         INT       21H       ; PRINT TOPRIGHT CHARACTER

SIDES:   LEA       BX,PNLD
         MOV       CL,[BX]
         DEC       CL
         DEC       CL
SIDELP:  PUSH      CX
         CALL      RCP       ; RESTORE CURSOR
         CALL      CDN       ; MOVE DOWN ONE LINE
         CALL      SCP
         LEA       BX,SDCH
         MOV       DL,[BX]
         PUSH      DX        ; SAVE SIDE CHARACTER
         MOV       AH,6
         INT       21H       ; PRINT LEFT SIDE
         MOV       DL,' '
         LEA       BX,PNLW   ; FETCH WIDTH
         MOV       CL,[BX]
         DEC       CL
         DEC       CL        ; CL = INTERNAL PANEL WIDTH
SPCLP:   INT       21H       ; PRINT SPACES INSIDE PANEL
         DEC       CL
         JNZ       SPCLP
         POP       DX        ; DL = SIDE CHATACTER
         INT       21H
         POP       CX
         DEC       CL
         JNZ       SIDELP    ; PRINT DOWN THE SIDES

BTM:     CALL      RCP       ; RESTORE CURSOR POSITION
         CALL      CDN       ; DOWN ONE LINE
         CALL      SCP
         LEA       BX,BLCH
         MOV       DL,[BX]   ; DL=BOTTOM LEFT CHAR.
         MOV       AH,6
         INT       21H
         LEA       BX,TBCH
         MOV       DL,[BX]   ; DL = BOTTOM CHAR.
         LEA       BX,PNLW
         MOV       CL,[BX]
         DEC       CL
         DEC       CL
BTMLP:   INT       21H
         DEC       CL
         JNZ       BTMLP     ; PRINT TO BOTTOM RIGHT
         LEA       BX,BRCH
         MOV       DL,[BX]
         INT       21H

         LEA       BX,SHAD
         MOV       AL,[BX]   ; FETCH ANY SHADOW ATTRIBUTE
         CMP       AL,255    ; 255 MEANS NO SHADOW
         JZ        DONE

         ;  NOW PRINT SHADOW STARTING WITH BOTTOM
         ; BUT FIRST SET BACKGROUND TO THE ATTRIBUTE USED BEFORE THE
         ; LAST CLS, OR DEFAULT TO BLACK

BTMSHAD: LEA       DX,PRESC
         MOV       AH,9
         INT       21H

         CALL      RCP
         CALL      CDN
         CALL      CRT
         LEA       SI,PNLW
         MOV       CL,[SI]   ; CL = WIDTH
         LEA       BX,SHESC+5
         MOV       AL,223    ; BOTTOM SHADOW CHARACTER
         MOV       [BX],AL
         LEA       DX,SHESC
BSLOOP:  MOV       AH,9
         INT       21H
         DEC       CL
         JNZ       BSLOOP
SDSHAD:  LEA       SI,PNLD
         MOV       CL,[SI]   ; CL = DEPTH
         DEC       CL        ; DEPTH - 1
         LEA       BX,SHESC+5
         MOV       AL,219    ; SIDE SHADOW CHARACTER
         MOV       [BX],AL   ; INSERT SHADOW GRAPHIC INTO STRING
         LEA       DX,SHESC
SSLOOP:  CALL      CLT       ; CURSOR BACK ONE
         CALL      CUP       ; AND UP ONE
         MOV       AH,9
         INT       21H
         DEC       CL
         JNZ       SSLOOP

DONE:    POP       BX        ; RECOVER DATA POINTER
         MOV       AL,TRUE
         RET

         ; - - - - - - - - - - - - - - - - - - - - - - - - - - - -

NXNUM:   ; MOVE BX FORWARD UNTIL IT POINTS TO A CHARACTER GREATER THAN 0

SKIPLP:  MOV       AL,[BX]
         CMP       AL,';'
         JZ        NXSKP     ; MOVE PAST ';'
         CMP       AL,'0'
         JL        NXSKP
         RET
NXSKP:   INC       BX
         JMP       SKIPLP


SCP:     PUSH      DX
         PUSH      AX
         LEA       DX,SCP$
         MOV       AH,9
         INT       21H       ; SAVE CURRENT CURSOR POSITION
         POP       AX
         POP       DX
         RET
SCP$     DB        27,'[s$'


RCP:     PUSH      DX
         PUSH      AX
         LEA       DX,RCP$
         MOV       AH,9
         INT       21H       ; RESTORE PREVIOUSLY SAVED CURSOR POSITION
         POP       AX
         POP       DX
         RET
RCP$     DB        27,'[u$'

CUP:     PUSH      DX
         PUSH      AX
         LEA       DX,CUP$
         MOV       AH,9
         INT       21H       ; MOVE CURSOR UP ONE LINE
         POP       AX
         POP       DX
         RET
CUP$     DB        27,'[1A$'

CDN:     PUSH      DX
         PUSH      AX
         LEA       DX,CDN$
         MOV       AH,9
         INT       21H       ; MOVE CURSOR DOWN ONE LINE
         POP       AX
         POP       DX
         RET
CDN$     DB        27,'[1B$'

CRT:     PUSH      DX
         PUSH      AX
         LEA       DX,CRT$
         MOV       AH,9
         INT       21H       ; MOVE CURSOR RIGHT ONE CHARACTER
         POP       AX
         POP       DX
         RET
CRT$     DB        27,'[1C$'

CLT:     PUSH      DX
         PUSH      AX
         LEA       DX,CLT$
         MOV       AH,9
         INT       21H       ; MOVE CURSOR LEFT ONE CHARACTER
         POP       AX
         POP       DX
         RET
CLT$     DB        27,'[1D$'

A2B:     ; CONVERTS AN ASCII SEQUENCE POINTED TO BY BX TO A
         ; BINARY VALUE <= 255 IN AL. AX <> 0 IF AN ERROR OCCURS

         MOV       AX,00     ; AX WILL HOLD RESULT
         MOV       DL,10     ; BASE 10 MULTIPLICAND
         MOV       CX,0

A2BLP:   MOV       CL,[BX]   ; FETCH POSSIBLE DIGIT
         CMP       CL,' '    ;
         JNZ       CHK2
A2BEX:   RET                 ; SPACE ENCOUNTERED SO RETURN
CHK2:    CMP       CL,3BH
         JZ        A2BEX     ; ; ENCOUNTERED SO RETURN
         CMP       CL,']'
         JZ        A2BEX     ; END OF PARAMETER LIST
         SUB       CL,30H    ; AL = DIGIT
         CMP       CL,9
         JLE       A2BOK
A2BERR:  MOV       AH,0FFH   ; FLAG ERROR WITH AH <> 0
         RET                 ; AND RETURN

A2BOK:   IMUL      DL        ; MULTIPLY INTERMEDIATE RESULT BY 10
         ADD       AX,CX     ; ADD UNITS
         CMP       AH,0
         JNZ       A2BERR    ; OVERFLOW ERROR
         INC       BX
         JMP       A2BLP

         ; = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =

LBYTE:   RET
START    ENDP
CSEG     ENDS
         END       ENTRY










